﻿Imports System.IO
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

Public Class Form1

    Private text1 As TextStyle
    Private text2 As TextStyle

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        text1 = TextStyles.Utility1("Street")
        text1.Font = New GeoFont("Arial", 4)
        text1.TextLineSegmentRatio = Double.MaxValue
        text1.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels
        text1.SplineType = SplineType.Default
        text1.OverlappingRule = LabelOverlappingRule.NoOverlapping
        text1.SuppressPartialLabels = True
        text1.GridSize = 1

        text2 = TextStyles.CreateSimpleTextStyle("Street", "Arial", 7, DrawingFontStyles.Bold, GeoColor.StandardColors.Black)
        text2.TextLineSegmentRatio = 100
        text2.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels
        text2.SplineType = SplineType.None
        text2.BestPlacement = False
        text2.GridSize = 1

        LoadMap()

    End Sub

    Private Sub LoadMap()
        map.MapUnit = GeographyUnit.DecimalDegree
        map.BackColor = Color.White

        Dim shapeOverlay As LayerOverlay = New LayerOverlay()

        Dim di As DirectoryInfo = New DirectoryInfo("../../Shape")
        For Each fi As FileInfo In di.GetFiles("*.shp")
            Dim myLayer As ShapeFileFeatureLayer = New ShapeFileFeatureLayer(fi.FullName)

            myLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Red, 2, True)
            myLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level16
            myLayer.ZoomLevelSet.ZoomLevel17.DefaultLineStyle = LineStyles.MajorRoad1()
            myLayer.ZoomLevelSet.ZoomLevel17.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

            myLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = text1
            myLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level16
            myLayer.ZoomLevelSet.ZoomLevel17.DefaultTextStyle = text2
            myLayer.ZoomLevelSet.ZoomLevel17.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

            myLayer.Open()
            map.CurrentExtent = myLayer.GetBoundingBox()
            myLayer.Close()

            shapeOverlay.Layers.Add(fi.Name, myLayer)
        Next

        map.Overlays.Add("ShapeOverlay", shapeOverlay)

        map.Refresh()
    End Sub

End Class
